/*
Storybook: Open Source software for novelists and authors.
Copyright (C) 2008 - 2012 Martin Mustun

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package storybook.model.state;

import i18n.I18N;
import storybook.model.hbn.entity.Event;

/**
 * @author jean
 *
 */
public class EventStatusModel extends AbstractStatusModel {

	private static final String L_COMBO = "timeevent.combo.";

	public EventStatusModel() {
		super();
		states.add(new EventStatus(Event.STATUS.MINUTE.ordinal(),
				I18N.getMsg(L_COMBO + "MINUTE"), null));
		states.add(new EventStatus(Event.STATUS.HOUR.ordinal(),
				I18N.getMsg(L_COMBO + "HOUR"), null));
		states.add(new EventStatus(Event.STATUS.DAY.ordinal(),
				I18N.getMsg(L_COMBO + "DAY"), null));
		states.add(new EventStatus(Event.STATUS.MONTH.ordinal(),
				I18N.getMsg(L_COMBO + "MONTH"), null));
		states.add(new EventStatus(Event.STATUS.YEAR.ordinal(),
				I18N.getMsg(L_COMBO + "YEAR"), null));
	}
}
